"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Binding_1 = require("./bindings/Binding");
var inversify_1 = require("inversify");
var planner_1 = require("inversify/lib/planning/planner");
function createContainerWithBindings(_a) {
    var autoBindInjectable = _a.autoBindInjectable, providers = _a.providers;
    var DEFAULT_AUTO_BIND = false;
    var container = new inversify_1.Container({
        defaultScope: 'Singleton',
        autoBindInjectable: autoBindInjectable !== void 0 ? autoBindInjectable : DEFAULT_AUTO_BIND
    });
    Binding_1.executeBindings(container, providers);
    return container;
}
exports.createContainerWithBindings = createContainerWithBindings;
function merge(container1, container2) {
    var container = new inversify_1.Container();
    var bindingDictionary = planner_1.getBindingDictionary(container);
    var bindingDictionary1 = planner_1.getBindingDictionary(container1);
    var bindingDictionary2 = planner_1.getBindingDictionary(container2);
    function copyDictionary(origin, destination) {
        origin.traverse(function (key, value) {
            value.forEach(function (binding) {
                destination.add(binding.serviceIdentifier, binding);
            });
        });
    }
    copyDictionary(bindingDictionary1, bindingDictionary);
    copyDictionary(bindingDictionary2, bindingDictionary);
    return container;
}
exports.merge = merge;
//# sourceMappingURL=container-service.js.map