"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
require("reflect-metadata");
var component_injection_1 = require("../component-injection");
var service_injection_1 = require("../service-injection");
function Inject() {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    if (args.length > 1) {
        var target = args[0], propertyKey = args[1], parameterIndex = args[2];
        decorate(target, propertyKey, parameterIndex);
    }
    else {
        var identifier_1 = args[0];
        return function (target, propertyKey, parameterIndex) {
            decorate(target, propertyKey, parameterIndex, identifier_1);
        };
    }
}
exports.Inject = Inject;
function decorate(target, propertyKey, parameterIndex, identifier) {
    if (typeof parameterIndex === 'number') {
        service_injection_1.serviceInject(target, propertyKey, parameterIndex, identifier);
    }
    else {
        component_injection_1.componentInject(target, propertyKey, identifier);
    }
}
//# sourceMappingURL=Inject.js.map