/// <reference types="react" />
import * as React from 'react';
import { Component, ReactNode } from 'react';
import { Container } from 'inversify';
export interface ModuleCreationOptions {
    getContainer(this: Component): Container;
    getChild(this: Component): ReactNode;
}
export declare function createModuleComponent({getContainer, getChild}: ModuleCreationOptions): {
    new (props: any, context: any): {
        container: Container;
        getChildContext(): {
            childContainers: any;
        };
        render(): any;
        setState<K extends never>(f: (prevState: {}, props: {}) => Pick<{}, K>, callback?: (() => any) | undefined): void;
        setState<K extends never>(state: Pick<{}, K>, callback?: (() => any) | undefined): void;
        forceUpdate(callBack?: (() => any) | undefined): void;
        props: Readonly<{
            children?: React.ReactNode;
        }> & Readonly<{}>;
        state: Readonly<{}>;
        context: any;
        refs: {
            [key: string]: React.ReactInstance;
        };
    };
    childContextTypes: {
        childContainers: any;
    };
    contextTypes: {
        childContainers: any;
    };
};
